/*
                                      divControl.js
                                      Version: 1.1

                                    by Vincenc Kurbus


  Desc    : Provides various DIV element manipulation functions
            * switchDiv()

  Notes   :

  Version control:
  -----------------------------------------------------------------------
  1.0   File created                                      by Vince
  1.1   Code revision                                     by Vince


*/


// ****************************************************************************************
// Desc: Differenciates between LAYERS and DIVs. (NetScape, Internet Explorer)
// ****************************************************************************************
var divVisible;
var divHidden;

divVisible  = "visible";
divHidden   = "hidden";


function isDivHidden( divId ){
 var jso = document.getElementById( divId );
 return ( jso.style.display == 'none' );
}


// *********************************************************************************************
// Desc    : shows / hides selected DIV name
// Params  : divName [string], onOff [integer]
// Returns : -
//
// ToDo    : check pre NS 6, IE 5.5 support for style.visibility.
// *********************************************************************************************
function switchDiv(divName, onOff, inLine) {
  
 if( document.getElementById( divName ) == undefined ) return;
 if(inLine == undefined) inLine = 0;
 var displayed = (inLine) ? 'inline' : 'block';
 
 // Netscape, Mozilla, Opera
 if( document.getElementById ){
  if( onOff == undefined ){
   if( document.getElementById(divName).style.visibility != divVisible ){
    document.getElementById(divName).style.visibility =  divVisible;
    document.getElementById(divName).style.display = displayed;
    return true;
   }
   else{
    document.getElementById(divName).style.visibility =  divHidden;
    document.getElementById(divName).style.display = 'none';
    return false;
   }
  }
  else{
   document.getElementById(divName).style.visibility = (onOff) ? divVisible : divHidden;
   document.getElementById(divName).style.display = (onOff) ? displayed : 'none';
   return (onOff) ? true : false;
  }
 }

 // IE
 else if(document.all){
  if(document.all(divName) == undefined) return;
  if(onOff == undefined){
   if( document.all(divName).style.visibility != divVisible ){
    document.all(divName).style.visibility = divVisible;
    document.all(divName).style.display = displayed;
    return true;
   }
   else{
    document.all(divName).style.visibility = divHidden;
    document.all(divName).style.display = 'none';
    return false;
   }
  }
  else{
   document.all(divName).style.visibility = (onOff) ? divVisible : divHidden;
   document.all(divName).style.display = (onOff) ? displayed : 'none';
   return (onOff) ? true : false;
  }
 }

 // Not supported.
 else{
  alert ('Your browser is not capable of displaying this content properly.');
 }
 return false;
}


// *********************************************************************************************
// Desc    : sets the class of the passed object to the desired class name
// Params  : jso [object], newClassName [string]
// Returns : -
// *********************************************************************************************
function setClass( jso, newClassName ){
 jso.className = newClassName;
 return;
}